/********************
USES m,e,f    
This Sketch Has the Correct Prop Turn Direction!
m,e work,  NO SOUND FROM F2 WITH f WITH STD 144PS
F0 Landing Lights
F1 Bell (Used for testing)
F2 Motor sound
F3 Main rear cabin lights
F4 front cabin lights
F5 Beginning Voice
F7 Ending Voice


* The DCC waveform is output on Pin 9, and is suitable for connection to an LMD18200-based booster directly,
* or to a single-ended-to-differential driver, to connect with most other kinds of boosters.
********************/
#include <DCCPacket.h>
#include <DCCPacketQueue.h>
#include <DCCPacketScheduler.h>
#define DCC_EN 2
#define low_rpm 6
#define high_rpm 9
unsigned char funct0 = 0x01;  //Landing Lights
unsigned char funct1 = 0x02;  //Bell (Used for testing)
unsigned char funct2 = 0x04;  //Motor sound
unsigned char funct3 = 0x08;  //Main rear cabin lights
unsigned char funct4 = 0x10;  //Front cabin lights
unsigned char funct5 = 0x01;  //Beginning Voice
unsigned char funct6 = 0x02;  //
unsigned char funct7 = 0x04;  //Ending Voice
unsigned char funct8 = 0x08;  //F8
unsigned char funct67 = 0x06; //F56 & F7

int arm_pin1 = 5;  // Mechanic on dock arm waving
int arm_pin2 = 6;

DCCPacketScheduler dps;
uint8_t functs = 0;
int8_t  speed_byte, old_speed = 0;
uint8_t F0 = 0;
uint8_t F1 = 0;
uint8_t F2 = 0;
uint8_t F3 = 0;
uint8_t F4 = 0;
uint8_t F40 = 0;
uint16_t decoder = 3;
int8_t speedtemp=0;
int8_t speedchar=0;
int8_t last_locoSpeed=0;
uint16_t locoAdr=3;  
unsigned long timing_start,timing_end;

void setup() {
  Serial.begin(9600);
  pinMode(DCC_EN,OUTPUT);    // will be kept high, DCC_EN pin
  pinMode(arm_pin1,OUTPUT);
  pinMode(arm_pin2,OUTPUT);
  digitalWrite(DCC_EN, 1);
  digitalWrite(arm_pin1, 0);
  digitalWrite(arm_pin2, 0);
  delay(10000);
  dps.setup();
  delay(5);
  dps.setSpeed128(locoAdr,DCC_SHORT_ADDRESS,1); // Speed 0 forward
  delay(5);       
  //dps.update();
  //delay(3000);
}
void loop() {  
 int chr; 
 dps.update();
    
      functs ^= funct3;
      dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F3 rear cabin lights on 
      wait_dcc(4000);
      //Serial.println("got to here 1");
            
      functs =funct4|funct3;
      dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F4 front cabin lights on
      wait_dcc(4000);
      //Serial.println("got to here 2");
      functs =funct4|funct3|funct0;
      dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F0 Landing Lights on
      wait_dcc(4000);
      
      dps.setFunctions5to8(locoAdr,DCC_SHORT_ADDRESS,funct5); // Play Beginning Voice
      wait_dcc(6);
      dps.setFunctions5to8(locoAdr,DCC_SHORT_ADDRESS,0);
      wait_dcc(1506);
      
      functs = funct2|funct4|funct3|funct0;
      dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F2 start motor sound
      wait_dcc(1);
      
      dps.setSpeed128(locoAdr,DCC_SHORT_ADDRESS,high_rpm); // Speed high_rpm
      //dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F2 start motor sound
      wait_dcc(1425);
      
      dps.setSpeed128(locoAdr,DCC_SHORT_ADDRESS,low_rpm); // Speed low_rpm
      //dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F2 start motor sound
      wait_dcc(1400);
      
      dps.setSpeed128(locoAdr,DCC_SHORT_ADDRESS,high_rpm); // Speed high_rpm
      
      wait_dcc(1425);
      //dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F2 start motor sound
      dps.setSpeed128(locoAdr,DCC_SHORT_ADDRESS,low_rpm); // Speed low_rpm
      wait_dcc(1400);
      
      dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F2 start motor sound
      dps.setSpeed128(locoAdr,DCC_SHORT_ADDRESS,high_rpm); // Speed .high_rpm
      wait_dcc(629);
      digitalWrite(arm_pin1, 1);
      wait_dcc (4940);
      digitalWrite(arm_pin1, 0);
      wait_dcc(2883);
      //wait_dcc(8452);
      
      functs =funct3|funct4|funct0;
      dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F2 motor sound off
      wait_dcc(5);
      
      dps.setSpeed128(locoAdr,DCC_SHORT_ADDRESS,low_rpm); // Speed low_rpm
      wait_dcc(6800);
      dps.setSpeed128(locoAdr,DCC_SHORT_ADDRESS,1); // Speed 0  
      wait_dcc(2900);
      
      dps.setFunctions5to8(locoAdr,DCC_SHORT_ADDRESS,funct7); // Play Ending Voice
      wait_dcc(2071);
      dps.setFunctions5to8(locoAdr,DCC_SHORT_ADDRESS,0);
      
      functs =funct3|funct4;
      dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F0 Landing Lights off
      wait_dcc(4000);
      functs =funct4;
      dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F3 rear cabin lights off
      wait_dcc(4000);
      
      functs =0;
      dps.setFunctions0to4(locoAdr,DCC_SHORT_ADDRESS,functs); // F4 front cabin lights off 
      wait_dcc(25000);
}
int wait_dcc (int wait_time) {
  
  timing_start = millis();
  timing_end = timing_start+ (wait_time);
  
  while (timing_start<timing_end) {
  dps.update();
  timing_start = millis();
  }
}

  
